diff -rup gcc/config/avr/avr.c gcc/config/avr/avr.c
--- gcc/config/avr/avr.c	2008-06-12 14:28:47.908832000 -0600
+++ gcc/config/avr/avr.c	2008-06-12 14:33:46.570975800 -0600
@@ -254,6 +254,7 @@ static const struct mcu_type_s avr_mcu_t
   { "at90pwm316",   ARCH_AVR5, "__AVR_AT90PWM316__" },
   { "atmega32m1",   ARCH_AVR5, "__AVR_ATmega32M1__" },
   { "atmega32c1",   ARCH_AVR5, "__AVR_ATmega32C1__" },
+  { "atmega32u4",   ARCH_AVR5, "__AVR_ATmega32U4__" },
   { "at90usb646",   ARCH_AVR5, "__AVR_AT90USB646__" },
   { "at90usb647",   ARCH_AVR5, "__AVR_AT90USB647__" },
   { "at94k",        ARCH_AVR5, "__AVR_AT94K__" },
diff -rup gcc/config/avr/avr.h gcc/config/avr/avr.h
--- gcc/config/avr/avr.h	2008-06-12 14:28:47.908832000 -0600
+++ gcc/config/avr/avr.h	2008-06-12 14:33:46.570975800 -0600
@@ -867,6 +867,7 @@ mmcu=*:-mmcu=%*}"
   mmcu=at90pwm*|\
   mmcu=atmega32c1|\
   mmcu=atmega32m1|\
+  mmcu=atmega32u4|\
   mmcu=at90usb*: -Tdata 0x800100}\
 %{mmcu=atmega640|\
   mmcu=atmega1280|\
@@ -978,6 +979,7 @@ mmcu=*:-mmcu=%*}"
 %{mmcu=at90pwm316:crt90pwm316.o%s} \
 %{mmcu=atmega32c1:crtm32c1.o%s} \
 %{mmcu=atmega32m1:crtm32m1.o%s} \
+%{mmcu=atmega32u4:crtm32u4.o%s} \
 %{mmcu=at90usb646:crtusb646.o%s} \
 %{mmcu=at90usb647:crtusb647.o%s} \
 %{mmcu=at94k:crtat94k.o%s} \
diff -rup gcc/config/avr/t-avr gcc/config/avr/t-avr
--- gcc/config/avr/t-avr	2008-06-12 14:28:47.908832000 -0600
+++ gcc/config/avr/t-avr	2008-06-12 14:33:46.586601000 -0600
@@ -116,6 +116,7 @@ MULTILIB_MATCHES = \
 	mmcu?avr5=mmcu?at90pwm316 \
 	mmcu?avr5=mmcu?atmega32c1 \
 	mmcu?avr5=mmcu?atmega32m1 \
+	mmcu?avr5=mmcu?atmega32u4 \
 	mmcu?avr5=mmcu?at90usb646 \
 	mmcu?avr5=mmcu?at90usb647 \
 	mmcu?avr5=mmcu?at94k \
